//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "example_dll.h"
#include <math.h>


#define C_CHANNELS 1

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TExample *Example;

int min(int value1, int value2)
{
  return ( (value1 < value2) ? value1 : value2);
}



//---------------------------------------------------------------------------
__fastcall TExample::TExample(TComponent* Owner)
  : TForm(Owner)
{
}


void __stdcall my_service(DWORD handle,void* Pmy_body,DWORD* buffer,DWORD size_of_buffer)
{
  int i;
  double average=0;
  int count=0;

  for(i=0;i!=(int)size_of_buffer;i++)
  {
    if((i%C_CHANNELS)==0) //Jedn se o prvn kanl
    {
      average+=buffer[i];
      count++;
    }
  }
  Example->ChannelOutput->Text=AnsiString(average/(float)count);
  //Example->ChannelOutput->Text=AnsiString(Example->count_sended);
}

DWORD HandleOfDevice;

//---------------------------------------------------------------------------
void __fastcall TExample::FormCreate(TObject *Sender)
{
  int result_;
  DWORD HandleOfDevice_loc;

  result_=make_library();

  if(result_!=0)
  {
    MessageBox(NULL,"patn zaveden knihovna.","Chyba!!",MB_OK);
    return;
  }

  //pokusim se inicializovat kartu zadaneho jmena
  result_=Td_Init_Driver(&HandleOfDevice,"EXAM_GENERATE");
  if(result_!=0)
  {
    MessageBox(NULL,"Nenalezeno dn aktivn zazen s nzvem EXAM_GENERATE, pouijte administran program [admin.exe]","Chyba",MB_ICONERROR);
    resolve_error(result_);
    Application->Terminate();
  }

  self_state=BEGIN_STATE;
}

//---------------------------------------------------------------------------
void __fastcall TExample::FormClose(TObject *Sender, TCloseAction &Action)
{
  DWORD result_;
  result_=Td_Close_Driver(HandleOfDevice);
  if(result_!=0)
  {
    //Nezdaen skonen komunikace, operaci nelze provst.
    resolve_error(result_);
    return;
  }

  if(buffer!=NULL)
    free(buffer);

  release_library();
}

//---------------------------------------------------------------------------
//Konfigurace cyklickho generovn
void __fastcall TExample::ConfigureCircleGenerateClick(TObject *Sender)
{
  #define SEND_SAMPLES 131072
  int i,j;
  DWORD result_;
  double frequency,period;
  DWORD buffer[SEND_SAMPLES];
  DWORD number_of_sended; //Pocet odeslanych vzorku
  DWORD inside_hw_device; //Pocet vzorku v bufferu HW zarizeni

  WORD W1;
  float R1;

  //Konfigurace generovanch kanl
  for(i=0;i!=C_CHANNELS;i++)
  {
    result_=Td_Config_Generating(HandleOfDevice,i,0,i,C_CHANNELS);
    if (result_!=0)
    {
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      return;
    }
  }

  //Nastaven frekvence generovn
  frequency=200;
  period=0;
  result_=Td_Config_Timing_Generating(HandleOfDevice,&frequency,&period);
  if(result_!=0)
  {
    //Nepodailo se nastavit frekvenci.
    resolve_error(result_);
    return;
  }

  for(j=0;j!=SEND_SAMPLES;j++)
  {
    R1=sin(j*3.14/100);
    W1=0x7FF+R1*0x7FF;
    buffer[j]=W1;
  }

  //Nastaveni reimu odesln dat
  result_=Td_Config_Generating_Mode(HandleOfDevice,2,1,0);
  if(result_!=0)
  {
    resolve_error(result_);
    return;
  }

  //Odelu data, kter chci cyklicky generovat
  result_=Td_Set_Buffer_Data(HandleOfDevice,&buffer[0],SEND_SAMPLES,&number_of_sended);

  if(result_!=0)
  {
    //Nepodailo se odeslat data.
    resolve_error(result_);
    return;
  }

  //Pokm a data doraz do modulu, pak teprve mu odstartovat generovn
  inside_hw_device=0;
  while(inside_hw_device!=number_of_sended)
  {
    result_=Td_Get_Generating_Status(HandleOfDevice,GET_BUFFER_HW_FILLED,&inside_hw_device);
    if(result_!=0)
    {
      resolve_error(result_);
      return;
    }
    Sleep(100);
  }

  MessageBox(NULL, AnsiString(inside_hw_device).c_str(), AnsiString(inside_hw_device).c_str(), MB_OK);
  
  change_state(CONFIGURED_CYCLING_STATE);
}

//---------------------------------------------------------------------------
//Start cyklickho generovn
void __fastcall TExample::StartCircleGenerateClick(TObject *Sender)
{
  DWORD result_;
  
  //Data dorazila, zanu generovat
  result_=Td_Start_Generating(HandleOfDevice);
  if(result_!=0)
  {
    //Nepodailo se odstartovat men.
    resolve_error(result_);
    return;
  }
  change_state(CYCLING_STATE);
}

//---------------------------------------------------------------------------
//Zastaven cyklickho generovn
void __fastcall TExample::StopCircleGenerateClick(TObject *Sender)
{
  DWORD result_;
  result_=Td_Stop_Generating(HandleOfDevice);
  if(result_!=0)
  {
    resolve_error(result_);
    return;
  }

  if(self_state==CYCLING_STATE)
    change_state(CONFIGURED_CYCLING_STATE);
  else
    change_state(BEGIN_STATE);
}

#define BASE_VALUE          512*2
#define STEP                min(BASE_VALUE*100,512*2*100)  //Krok po kterm pjmm/generuji
#define PERIOD_LENGTH       (STEP)                         //Dlka periody Sin, kterou generuji na vstup
#define FREQUENCY           (10000)
#define PACKET              10                             //Poet souasn odeslnch

void __fastcall TExample::GenerateMeasureContinualClick(TObject *Sender)
{
  Fmeasure=ChMeasure_wanted->Checked;
  Fgenerate=ChGenerate_wanted->Checked;

  int i,j;
  DWORD result_;
  double frequency,period;
  DWORD number_of_sended; //Pocet odeslanych vzorku
  DWORD inside_hw_device; //Pocet vzorku v bufferu HW zarizeni


  WORD W1;
  float R1;

  if(Fmeasure)
  {
    //Je poadovno men
    //-------------------------------------------------------------------------

    //Nastavime analogove vstupni kanaly, zesileni zvolime pro vsechny 1x
    for(i=0;i!=C_CHANNELS;i++)
    {
      result_=Td_Config_Acquisition(HandleOfDevice,0,0,i,C_CHANNELS);
      if (result_!=0)
      {
        //Nepodailo se nastavit kanly.
        resolve_error(result_);
        return;
      }
    }

    //Nastaven frekvence
    frequency=FREQUENCY;
    period=0;
    result_=Td_Config_Timing_Acquisition(HandleOfDevice,&frequency,&period);
    if(result_!=0)
    {
      //Nepodailo se nastavit frekvenci tae.
      resolve_error(result_);
      return;
    }

    change_state(CONTINAL_MEASURE_STATE);
  }

  if(Fgenerate)
  {
    //Je poadovno generovn
    //-------------------------------------------------------------------------
    if(buffer!=NULL)
      free(buffer);

    buffer=(DWORD*)malloc(sizeof(DWORD)*STEP*2);

    for(i=0;i!=C_CHANNELS;i++)
    {
      result_=Td_Config_Generating(HandleOfDevice,i,0,i,C_CHANNELS);
      if (result_!=0)
      {
        //Nepodailo se nastavit kanly.
        resolve_error(result_);
        return;
      }
    }

    //Nastaven frekvence
    frequency=FREQUENCY;
    period=0;
    result_=Td_Config_Timing_Generating(HandleOfDevice,&frequency,&period);
    if(result_!=0)
    {
      //Nepodailo se nastavit frekvenci.
      resolve_error(result_);
      return;
    }

    for(j=0;j!=2*STEP;j++)
    {
      R1=sin(j*2*3.14/PERIOD_LENGTH);
      W1=0x7FF+R1*0x7FF;
      buffer[j]=W1;
    }
    result_=Td_Config_Generating_Mode(HandleOfDevice,2,0,(Fmeasure)?1:0);
    if(result_!=0)
    {
      //Nepodailo se nakonfigurovat generovn.
      resolve_error(result_);
      return;
    }

    count_sended=0;
    result_=Td_Set_Buffer_Data(HandleOfDevice,&buffer[0],STEP,&number_of_sended);
    if(result_!=0)
    {
      //Nepodailo se odeslat data.
      resolve_error(result_);
      return;
    }

    count_sended+=number_of_sended;

    //Pokm a st dat doraz do modulu, pak teprve mu odstartovat generovn
    // zazen vyaduje pi startu ji st dat
    inside_hw_device=0;
    while(inside_hw_device!=number_of_sended)
    {
      result_=Td_Get_Generating_Status(HandleOfDevice,GET_BUFFER_HW_FILLED,&inside_hw_device);
      if(result_!=0)
      {
        resolve_error(result_);
        return;
      }
      Sleep(100);
    }

    result_=Td_Start_Generating(HandleOfDevice);
    if(result_!=0)
    {
      //Nepodailo se odstartovat generovn.
      resolve_error(result_);
      return;
    }

    change_state(CONTINAL_GENERATE_STATE);
  }

  if(Fmeasure)
  {
    //Odstarujeme mereni
    result_=Td_Start_Acquisition(HandleOfDevice,2);
    if(result_!=0)
    {
      //Nepodailo se odstartovat men.
      resolve_error(result_);
      return;
    }

    result_=Td_Start_Buffer_Data_Request_Sync(HandleOfDevice,&my_service,-1,STEP,Example);
    if(result_!=0)
    {
      //Nepodailo se odstartovat men.
      resolve_error(result_);
      return;
    }
    change_state(CONTINAL_GENERATE_MEASURE_STATE);
    InputScanTimer->Enabled=true;
  }

  if(Fgenerate)
  {
    pulse_data();

    //Periodu timeru [mS] zvolim o malo kratsi nez je treba pro mozne zpozdeni
    TimerGenerateData->Interval=(float(STEP)/frequency)*1000*PACKET*0.4;
    TimerGenerateData->Enabled=true;

    OutputScanTimer->Enabled=true;
  }
}

void __fastcall TExample::StopContinualClick(TObject *Sender)
{
  DWORD result_;
  
  InputScanTimer->Enabled=false;
  OutputScanTimer->Enabled=false;  
  TimerGenerateData->Enabled=false;

  if(Fgenerate)
  {
    result_=Td_Stop_Generating(HandleOfDevice);
    if(result_!=0)
      resolve_error(result_);  //Nepodailo se zastavit generovn.
  }

  if(Fmeasure)
  {
    result_=Td_Stop_Buffer_Data_Request(HandleOfDevice);
    if(result_!=0)
      resolve_error(result_);

    result_=Td_Stop_Acquisition(HandleOfDevice);
    if(result_!=0)
      resolve_error(result_);
  }
  change_state(BEGIN_STATE);
}

void __fastcall TExample::FormActivate(TObject *Sender)
{
  //Refresh vzhledu tlatek
  change_state(self_state);
}

void __fastcall TExample::TimerGenerateDataTimer(TObject *Sender)
{
  pulse_data();
}

void TExample::pulse_data()
{
  int i;
  DWORD result_;
  DWORD number_of_sended;

  for(i=0;i!=PACKET;i++)
  {
    result_=Td_Set_Buffer_Data(HandleOfDevice,&buffer[count_sended%STEP],STEP,&number_of_sended);
    if(result_!=0)
    {
      //Nepodailo se odeslat data.
      resolve_error(result_);
      return;
    }
    count_sended+=number_of_sended;
  }
}

//Procedura, ktera vytvori message box s chybovou zprvou
void TExample::resolve_error(DWORD n_error)
{
  char function_[1000];
  char error_[1000];

  Td_Get_ErrorMessage(n_error,&error_[0],&function_[0]);
  MessageBox(NULL,&function_[0],&error_[0],MB_ICONERROR);
}

//Funkce kter zmn stav programu, zrove updatuje patin vzhled
void TExample::change_state(int new_self_state)
{
  //Vypne vechny tlatka
  ConfigureCircleGenerate->Enabled=false;
  StartCircleGenerate->Enabled=false;
  StopCircleGenerate->Enabled=false;
  StopContinual->Enabled=false;
  GenerateMeasureContinual->Enabled=false;

  self_state=new_self_state;

  //a zapne vybran podle stavu
  switch(self_state)
  {
    case BEGIN_STATE:
    {
      GenerateMeasureContinual->Enabled=true;
      ConfigureCircleGenerate->Enabled=true;
      break;
    }

    case CONFIGURED_CYCLING_STATE:
    {
      StartCircleGenerate->Enabled=true;
      StopCircleGenerate->Enabled=true;
      ConfigureCircleGenerate->Enabled=true;
    }

    case CYCLING_STATE:
    {
      StopCircleGenerate->Enabled=true;
      break;
    }

    case CONTINAL_MEASURE_STATE:
    case CONTINAL_GENERATE_STATE:
    case CONTINAL_GENERATE_MEASURE_STATE:
    {
      StopContinual->Enabled=true;
      break;
    }
  }
}

void __fastcall TExample::OutputScanTimerTimer(TObject *Sender)
{
  DWORD result_;
  DWORD inside_hw_device;

  result_=Td_Get_Generating_Status(HandleOfDevice,GET_BUFFER_SW_FILLED,&inside_hw_device);
  if(result_!=0)
  {
    resolve_error(result_);
    return;
  }
  OutputBufferText->Text=AnsiString(inside_hw_device);
}


void __fastcall TExample::InputScanTimerTimer(TObject *Sender)
{
  DWORD result_;
  DWORD count;
  Td_Get_Buffer_Status(HandleOfDevice,&count);
  InputBufferText->Text=AnsiString(count);
}


