unit example_dll;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, tedia_DAQ01h, Registry, Math, ComCtrls,
  AppEvnts;

const
  MY_MESSAGE=WM_USER+10; //Uzivatelska zprava pouzita pro volani

const
  MAKE_LOG=false;  //false-log nevytvoren, true-log vytvoren

type
  ADWord=array of DWord;
  TExample = class(TForm)
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    CNT0_1: TRadioButton;
    CNT0_2: TRadioButton;
    CNT0_3: TRadioButton;
    GroupBox5: TGroupBox;
    CNT1_1: TRadioButton;
    CNT1_2: TRadioButton;
    CNT1_3: TRadioButton;
    CNT1_0: TRadioButton;
    CNT0_0: TRadioButton;
    Panel2: TPanel;
    GroupBox6: TGroupBox;
    Label2: TLabel;
    LabeledEdit2: TLabeledEdit;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    SwPulse: TButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    AWaitConfig: TButton;
    LabeledEdit1: TLabeledEdit;
    PWaitConfig: TButton;
    StringGrid1: TStringGrid;
    TabSheet2: TTabSheet;
    StringGrid2: TStringGrid;
    SWConfig: TButton;
    Button6: TButton;
    Panel3: TPanel;
    Edit1: TEdit;
    Label3: TLabel;
    GroupBox8: TGroupBox;
    Stop: TButton;
    procedure SwPulseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AWaitConfigClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PWaitConfigClick(Sender: TObject);
    procedure SWConfigClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure StopClick(Sender: TObject);
  private
  public
    count_registry_card:DWord;
    cesta_k_tedia_dll:string;
    aktivni_sloupec:DWord;
    call_buffer:PDWord;
    call_size_of_buffer:DWord;

    function M_stop_measuring():DWord;      //Zastavi provadene mereni
    function M_close_card():DWord;          //Uzavre spojeni s kartou
    procedure M_set_visual_busy();          //Spusteno mereni=> vypne ovladaci prvky spoustejici mereni a zapne zastavujici
    procedure M_set_visual_ready();         //Zastaveno mereni=> vypne ovladaci prvky zastavujici mereni a zapne spoustejici
    procedure resolve_error(n_error:Dword); //Procedura, ktera vytvori message box s chybovou zpravou
  end;

var
  Example: TExample;
  Ihandle:PHandle;
  number_of_channels:DWord;
  buffer:PDWord;
  state:DWord;
  is_running:boolean;     //Signalizuje probihajici mereni
implementation

{$R *.dfm}

procedure TExample.SwPulseClick(Sender: TObject);
var
  result_:DWord;
  i:DWord;
  myRect: TGridRect;
begin
  if(is_running) and (state=0) then
  begin
    //Spustime SW pulsem mereni jedne sekvence
    result_:=Td_Get_SingleAcquisition(Ihandle,buffer,number_of_channels);
    if result_<>0 then
    begin
      //Nepodailo se odmit vzorek.
      resolve_error(result_);
      Exit;
    end;

    //Ulozime data do StringGridu
    StringGrid1.RowCount:=max(number_of_channels+1,2);
    for i:=1 to number_of_channels do
    begin
      StringGrid1.Cells[aktivni_sloupec,i]:=IntToStr(ADWord(buffer)[i-1]);
    end;

    myRect.Left := aktivni_sloupec;
    myRect.Top := 1;
    myRect.Right := aktivni_sloupec;
    myRect.Bottom := number_of_channels+1;
    StringGrid1.Selection := myRect;

    aktivni_sloupec:= (aktivni_sloupec+1) mod 5;
  end
  else
  begin
    Application.MessageBox('Karta nen nakonfigurovna pro softwarov spoutn.','Chyba!',MB_ICONERROR);
    Exit;
  end;
end;

procedure TExample.FormCreate(Sender: TObject);
var
  result_:DWord;
  i:integer;
begin
  M_set_visual_ready();

  is_running:=false;

  aktivni_sloupec:=0;

  //Otevreme kartu
  result_:=Td_Init_Driver(@Ihandle,PChar('EXAM_ANALOG'));
  if result_<>0 then
  begin
   Application.MessageBox('Nenalezeno dn aktivn zazen s nzvem EXAM_ANALOG, pouijte administran program [admin.exe].','Chyba!',MB_ICONERROR);
    resolve_error(result_);
    Application.Terminate;
  end;

  for i:=0 to 1 do     //Ulozime do gridu implicitni hodnoty
  begin
    StringGrid2.Cells[i,1]:='4000';
  end;
end;

procedure moje_obsluha(handle:PHandle;Pmy_body:pointer;buffer:PDWord;size_of_buffer:DWord); stdcall;
var
  i:DWord;
  myRect:TGridRect;

begin
  //Ulozime data do StringGridu
  Example.StringGrid1.RowCount:=max(min(size_of_buffer,number_of_channels)+1,2);
  for i:=1 to min(size_of_buffer,number_of_channels) do
  begin
    Example.StringGrid1.Cells[Example.aktivni_sloupec,i]:=IntToStr(ADWord(buffer)[i-1]);
  end;

  myRect.Left := Example.aktivni_sloupec;
  myRect.Top := 1;
  myRect.Right := Example.aktivni_sloupec;
  myRect.Bottom := size_of_buffer+1;
  Example.StringGrid1.Selection := myRect;
  Example.aktivni_sloupec:= (Example.aktivni_sloupec+1) mod 5;
  Example.Refresh();
end;

procedure TExample.AWaitConfigClick(Sender: TObject);
var
  result_:DWord;
  i:integer;
  frequency:double;
  period:double;
  requested_row:integer;
  call_every:DWord;
  CfgCNT0:integer;
  CfgCNT1:integer;
  number_of_all_channels:integer;
begin
  M_set_visual_busy();
  //Zastaveni mereni, kdyz se meri
  if(is_running) then
  begin
    result_:=M_stop_measuring();
    if(result_<>0) then
    begin
      exit;
    end;
  end;

  state:=1;//Nastavi se stav podle typu mereni, ktere probiha

  try
    number_of_channels:=StrToInt(LabeledEdit2.Text);
  except
    Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  if number_of_channels<=0 then
  begin
    Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  number_of_all_channels:=number_of_channels;
  if not(CNT0_0.Checked) then inc(number_of_all_channels);
  if not(CNT1_0.Checked) then inc(number_of_all_channels);

  try
    frequency:=StrToFloat(LabeledEdit1.Text);
  except
    Application.MessageBox('Frekvence mus bt slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  if frequency<=31 then
  begin
    Application.MessageBox('Frekvenece mus bt v interval 31Hz az 2Mhz.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  //Nastavime analogove vstupni kanaly, zesileni zvolime pro vsechny 1x
  for i:=0 to number_of_channels-1 do
  begin
    result_:=Td_Config_Acquisition(Ihandle,i,0,i,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
  end;

  if not(CNT0_0.Checked) then //Pokud si prejeme zapnout counter(popisovac) dat ulozime kanaly 256 nebo 257
  begin
    result_:=Td_Config_Acquisition(Ihandle,256,0,number_of_channels,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
    inc(number_of_channels);
  end;

  if not(CNT1_0.Checked) then
  begin
    result_:=Td_Config_Acquisition(Ihandle,257,0,number_of_channels,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
    inc(number_of_channels);
  end;

  CfgCNT0:=0;
  CfgCNT1:=0;
  if (CNT0_0.Checked) then CfgCNT0:=0;
  if (CNT0_1.Checked) then CfgCNT0:=1;
  if (CNT0_2.Checked) then CfgCNT0:=2;
  if (CNT0_3.Checked) then CfgCNT0:=3;

  if (CNT1_0.Checked) then CfgCNT1:=0;
  if (CNT1_1.Checked) then CfgCNT1:=1;
  if (CNT1_2.Checked) then CfgCNT1:=2;
  if (CNT1_3.Checked) then CfgCNT1:=3;

  //Odesleme data scan. citacum
  result_:=Td_Config_ScanCounter(Ihandle,CfgCNT0,0);
  if result_<>0 then
  begin
    //Nepodailo se nastavit popisujc ta.
    resolve_error(result_);
    Exit;
  end;
  result_:=Td_Config_ScanCounter(Ihandle,CfgCNT1,1);
  if result_<>0 then
  begin
    //Nepodailo se nastavit popisujc ta.
    resolve_error(result_);
    Exit;
  end;

  //Nastavime frekvenci
  period:=0;
  result_:=Td_Config_Timing_Acquisition(Ihandle,@frequency,@period);
  if result_<>0 then
  begin
    //Nepodailo se nastavit frekvenci tae.
    resolve_error(result_);
    Exit;
  end;

  //Odstarujeme mereni spoustene citacem
  result_:=Td_Start_Acquisition(Ihandle,2);
  if result_<>0 then
  begin
    Application.MessageBox('Nepodailo se odstartovat men.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  aktivni_sloupec:=0;
  is_running:=true;
  requested_row:=-1;  //Data se budou cist neustale
  call_every:=10;     //Po deseti kompletnich mericich sekvencich se bude volat "moje_obsluha"
  result_:=Td_Start_Buffer_Data_Request_Sync(Ihandle,moje_obsluha,requested_row,call_every,Example);
  if result_<>0 then
  begin
    //Nepodailo se odmit vzorek.
    resolve_error(result_);
    Exit;
  end;
end;

procedure TExample.FormClose(Sender: TObject; var Action: TCloseAction);
var
  result_:DWord;
begin
  if(is_running) then
  begin
    result_:=M_stop_measuring();
    if(result_<>0) then exit;
  end;

  Application.ProcessMessages();

  M_close_card();  //Uzavreni karty
end;

procedure TExample.PWaitConfigClick(Sender: TObject);
var
  result_,i,j:DWord;
  frequency:double;
  period:double;
  count_new_row:DWord;
  myRect: TGridRect;

  buffer_loc:PDWord;    //Uzivatelsky buffer pro alokovane data
  size_of_buffer:DWord; //Delka uziv bufferu

  kompletnich_vzorku:DWord;
  digital_input:DWord;

  CfgCNT0:integer;
  CfgCNT1:integer;

  number_of_all_channels:integer;
  infor_cnt:DWord;
begin
  try
    M_set_visual_busy();

    //Zastavim mereni, kdyz se meri
    if(is_running) then
    begin
      result_:=M_stop_measuring();
      if(result_<>0) then
      begin
        exit;
      end;
    end;

    state:=2; //Nastavim stav podle typu mereni, ktere probiha

    //Nacteme hodnoty ovladacich prvku
    try
      number_of_channels:=StrToInt(LabeledEdit2.Text);
    except
      Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
      Exit;
    end;

    if number_of_channels<=0 then
    begin
      Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
      Exit;
    end;

    number_of_all_channels:=number_of_channels;
    if not(CNT0_0.Checked) then inc(number_of_all_channels);
    if not(CNT1_0.Checked) then inc(number_of_all_channels);

    try
      frequency:=StrToFloat(LabeledEdit1.Text);
    except
      Application.MessageBox('Frekvence mus bt slo.','Chyba!',MB_ICONERROR);
      Exit;
    end;

    if frequency<=31 then
    begin
      Application.MessageBox('Frekvenece mus bt v interval 31Hz az 2Mhz.','Chyba!',MB_ICONERROR);
      Exit;
    end;


    //Nastavime analogove vstupni kanaly, zesileni zvolime pro vsechny 1x
    for i:=0 to number_of_channels-1 do
    begin
      result_:=Td_Config_Acquisition(Ihandle,i,0,i,number_of_all_channels);
      if result_<>0 then
      begin
        //Nepodailo se nastavit kanly.
        resolve_error(result_);
        Exit;
      end;
    end;

    if not(CNT0_0.Checked) then //Pokud si prejeme zapnout counter(popisovac) dat ulozime kanaly 256 nebo 257
    begin
      result_:=Td_Config_Acquisition(Ihandle,256,0,number_of_channels,number_of_all_channels);
      if result_<>0 then
      begin
        //Nepodailo se nastavit kanly.
        resolve_error(result_);
        Exit;
      end;
      inc(number_of_channels);
    end;

    if not(CNT1_0.Checked) then
    begin
      result_:=Td_Config_Acquisition(Ihandle,257,0,number_of_channels,number_of_all_channels);
      if result_<>0 then
      begin
        //Nepodailo se nastavit kanly.
        resolve_error(result_);
        Exit;
      end;
      inc(number_of_channels);
    end;

    CfgCNT0:=0;
    CfgCNT1:=0;
    if (CNT0_0.Checked) then CfgCNT0:=0;
    if (CNT0_1.Checked) then CfgCNT0:=1;
    if (CNT0_2.Checked) then CfgCNT0:=2;
    if (CNT0_3.Checked) then CfgCNT0:=3;

    if (CNT1_0.Checked) then CfgCNT1:=0;
    if (CNT1_1.Checked) then CfgCNT1:=1;
    if (CNT1_2.Checked) then CfgCNT1:=2;
    if (CNT1_3.Checked) then CfgCNT1:=3;

    //Odesleme data scan. citacum
    result_:=Td_Config_ScanCounter(Ihandle,CfgCNT0,0);
    if result_<>0 then
    begin
      //Nepodailo se nastavit popisujc ta.
      resolve_error(result_);
      Exit;
    end;
    result_:=Td_Config_ScanCounter(Ihandle,CfgCNT1,1);
    if result_<>0 then
    begin
      //Nepodailo se nastavit popisujc ta.
      resolve_error(result_);
      Exit;
    end;


    //Nastavime frekvenci
    period:=0;
    result_:=Td_Config_Timing_Acquisition(Ihandle,@frequency,@period);
    if result_<>0 then
    begin
      //Nepodailo se nastavit frekvenci tae.
      resolve_error(result_);
      Exit;
    end;

    //Odstarujeme mereni s SW rizenim
    result_:=Td_Start_Acquisition(Ihandle,2);
    if result_<>0 then
    begin
      //Nepodailo se odstartovat men.
      resolve_error(result_);
      Exit;
    end;

    size_of_buffer:=10000;
    GetMem(buffer_loc,sizeof(DWord)*size_of_buffer);
    aktivni_sloupec:=0;
    count_new_row:=0;
    is_running:=true;
    infor_cnt:=0;
    while (is_running) do //Tato smycka se prerusi ukonceni formulare (OnClose nastavi is_running na false)
    begin
      //Posleme si pro data
      result_:=Td_Get_Buffer_Data(Ihandle,buffer_loc,size_of_buffer,@count_new_row);
      if result_<>0 then
      begin
        //Nepodailo se namit hodnoty.
        resolve_error(result_);
        Exit;
      end;

      //prisly nejake data?
      kompletnich_vzorku:=count_new_row div number_of_channels;
      if(kompletnich_vzorku>0) then
      begin
        for i:=0 to kompletnich_vzorku-1 do
        begin
          StringGrid1.RowCount:=max(min(size_of_buffer,number_of_channels)+1,2);
          for j:=1 to min(size_of_buffer,number_of_channels) do
          begin
            StringGrid1.Cells[aktivni_sloupec,j]:=IntToStr(ADWord(buffer_loc)[j-1]);
          end;

          myRect.Left := aktivni_sloupec;
          myRect.Top := 1;
          myRect.Right := aktivni_sloupec;
          myRect.Bottom := size_of_buffer+1;
          StringGrid1.Selection := myRect;
          StringGrid1.Refresh();
          aktivni_sloupec:= (aktivni_sloupec+1) mod 5;
        end;

        digital_input:=0;

        //Zjistime hodnotu digitalniho vstupu
        result_:=Td_Get_Di(Ihandle,0,@digital_input,1);
        if result_<>0 then
        begin
          //Nezdailo se zavolat funkci Td_Get_Di.
          resolve_error(result_);
          Exit;
        end;
        
        Edit1.Text:=IntToStr(digital_input);
        Edit1.Refresh();
      end;
      inc(infor_cnt);
      if((infor_cnt mod 10)=0) then
      begin
        Application.ProcessMessages();
      end;
      sleep(5);
    end;

    Dispose(buffer_loc);
  finally
    M_set_visual_ready();
  end;
end;

procedure TExample.SWConfigClick(Sender: TObject);
var
  result_:DWord;
  i:integer;
  CfgCNT0:integer;
  CfgCNT1:integer;
  number_of_all_channels:integer;
begin
  M_set_visual_busy();

  //Zastavime mereni, kdyz se meri
  if(is_running) then
  begin
    result_:=M_stop_measuring();
    if(result_<>0) then
    begin
      exit;
    end;
  end;

  state:=0; //Nastavime stav podle typu mereni, ktere probiha

  try
    number_of_channels:=StrToInt(LabeledEdit2.Text);
  except
    Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  StringGrid2.ColCount:=number_of_channels;

  if number_of_channels<=0 then
  begin
    Application.MessageBox('Poet kanl mus bt cel kladn slo.','Chyba!',MB_ICONERROR);
    Exit;
  end;

  number_of_all_channels:=number_of_channels;
  if not(CNT0_0.Checked) then inc(number_of_all_channels);
  if not(CNT1_0.Checked) then inc(number_of_all_channels);

  //Nastavime analogove vstupni kanaly, zesileni zvolime pro vsechny 1x
  for i:=0 to number_of_channels-1 do
  begin
    result_:=Td_Config_Acquisition(Ihandle,i,0,i,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
  end;

  if not(CNT0_0.Checked) then //Pokud si prejeme zapnout counter(popisovac) dat ulozime kanaly 256 nebo 257
  begin
    result_:=Td_Config_Acquisition(Ihandle,256,0,number_of_channels,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
    inc(number_of_channels);
  end;

  if not(CNT1_0.Checked) then
  begin
    result_:=Td_Config_Acquisition(Ihandle,257,0,number_of_channels,number_of_all_channels);
    if result_<>0 then
    begin
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      Exit;
    end;
    inc(number_of_channels);
  end;

  CfgCNT0:=0;
  CfgCNT1:=0;
  if (CNT0_0.Checked) then CfgCNT0:=0;
  if (CNT0_1.Checked) then CfgCNT0:=1;
  if (CNT0_2.Checked) then CfgCNT0:=2;
  if (CNT0_3.Checked) then CfgCNT0:=3;

  if (CNT1_0.Checked) then CfgCNT1:=0;
  if (CNT1_1.Checked) then CfgCNT1:=1;
  if (CNT1_2.Checked) then CfgCNT1:=2;
  if (CNT1_3.Checked) then CfgCNT1:=3;

  //Odesleme data scan. citacum
  result_:=Td_Config_ScanCounter(Ihandle,CfgCNT0,0);
  if result_<>0 then
  begin
    //Nepodailo se nastavit popisujc ta.
    resolve_error(result_);
    Exit;
  end;
  result_:=Td_Config_ScanCounter(Ihandle,CfgCNT1,1);
  if result_<>0 then
  begin
    //Nepodailo se nastavit popisujc ta.
    resolve_error(result_);
    Exit;
  end;

  //Odstarujeme mereni s SW rizenim
  result_:=Td_Start_Acquisition(Ihandle,1);
  if result_<>0 then
  begin
    //Nepodailo se odstartovat men.
    resolve_error(result_);
    Exit;
  end;

  //Alokujeme buffer
  getMem(buffer,number_of_channels*sizeof(DWord));
  is_running:=true;
end;

procedure TExample.Button6Click(Sender: TObject);
var
  i,result_:DWord;
  set_number:word;
begin
  if(is_running) then //Presvedcime se, jestli je karta ve stavu mereni
  begin
    for i:=0 to number_of_channels-1 do
    begin
      try
        set_number:=StrToInt(StringGrid2.Cells[i,1]);
      Except
        Application.MessageBox('V tabulce muste nastavit takov sla jak mohou analogov vstupy nastavit [0..4095].','Chyba!',MB_ICONERROR);
        Exit;
      end;

      if(set_number>4095) then  //Spravny format cisla?
      begin
        Application.MessageBox('V tabulce muste nastavit takov sla jak mohou analogov vstupy nastavit [0..4095].','Chyba!',MB_ICONERROR);
        Exit;
      end;

      result_:=Td_Set_AO(Ihandle,i,@set_number,1);
      if (result_<>0) then
      begin
        //Nepodailo nastavit analogov vstupy.
        resolve_error(result_);
        Exit;
      end;
    end;
  end
  else
    ShowMessage('Nejprve spuste jakkoliv men na lit "analogov vstupy" pro oteven karty.');
end;

//vlastni obsluha zpravy poslane pri zavolani uzivatelske funkce dynamickou knihovnou
procedure TExample.StopClick(Sender: TObject);
var
  result_:DWord;
begin
  if(is_running) then
  begin
    result_:=M_stop_measuring();
    if(result_<>0) then
    begin
      exit;
    end;

    //state=0 mereni SW pulsem a state=1 mereni casovacem active wait potrebuji nastavit ze se nemeri
    if(state<>2) then
    begin
      M_set_visual_ready();
    end;
  end;
end;

//Pomocne procedury pro zastaveni mereni a uzavreni karty
function TExample.M_stop_measuring():DWord;
var
  result_:DWord;
begin
  result_:=Td_Stop_Acquisition(Ihandle);
  if result_<>0 then
  begin
    //Nezdailo se zastavit men.
    resolve_error(result_);
    M_stop_measuring:=1;
    Exit;
  end;
  is_running:=false;
  M_stop_measuring:=0;
end;

function TExample.M_close_card():DWord;
var
  result_:DWord;
begin
  result_:=Td_Close_Driver(Ihandle);
  if result_<>0 then
  begin
    //Nezdailo se zastavit men.
    resolve_error(result_);
    M_close_card:=1;
    Exit;
  end;
  M_close_card:=0;
end;

procedure TExample.M_set_visual_busy();
begin
  SWConfig.Enabled:=false;
  AWaitConfig.Enabled:=false;
  PWaitConfig.Enabled:=false;
  Stop.Enabled:=true;
end;

procedure TExample.M_set_visual_ready();
begin
  SWConfig.Enabled:=true;
  AWaitConfig.Enabled:=true;
  PWaitConfig.Enabled:=true;
  Stop.Enabled:=false;
end;

//Procedura, ktera vytvori message box s chybovou zprvou
procedure TExample.resolve_error(n_error:DWord);
var
  function_:array[0..1000] of char;
  error_:array[0..1000] of char;
begin
  Td_Get_ErrorMessage(n_error,PChar(@function_),PChar(@error_));
  Application.MessageBox(PChar(@error_),PChar(@function_),MB_ICONERROR);
end;

end.
